from gamegrid import*
from random import *
from particleSystem import ParticleSystem
from hindernisSystem import HindernisSystem

class Ball(Actor):
    def __init__(self, winX, winY, anzeige, window, ballCollisionListener):
        Actor.__init__(self, "sprites/ball.png")
        self.anzeige = anzeige
        self.winX = winX
        self.winY = winY
        self.maxX = winX - 20
        self.minX = 20
        self.maxY = winY - 20
        self.minY = 20
        self.randFaktor = 20
        self.start = False
        self.ballCollisionListener = ballCollisionListener
        self.particleSystem = ParticleSystem(window)
        self.hindernisSystem = HindernisSystem(window, winX, winY)
        self.speedCounter = 0
        
    def act(self):
        
        if (self.speedCounter > 0):
            self.setSlowDown(1)
            self.speedCounter -= 1
        else:
            self.setSlowDown(2)
            
        self.setOnTop()
        self.particleSystem.update(self.getX(), self.getY(), self.winX, self.winY)
        self.hindernisSystem.update(self, self.ballCollisionListener)
        if self.start == True:
            self.move()
            self.move()
        
        richtung = self.getDirection()
        
        if (self.getX() > self.maxX or self.getX() < self.minX): #Setzte den Ball bei abpraller zurueck und zaehle Punkte eines Spielers hoch
            if(self.getX() > self.maxX):
                self.anzeige.addPunkteL(1)
            else:
                self.anzeige.addPunkteR(1)
            
            self.setX(self.maxX//2 + 8)
            self.setY(self.maxY//2 + 8) 
            self.setRandDirection()
            richtung = self.getDirection()
            self.start = False
            
            self.anzeige.updateBG()
            
            
        if (self.getY() > self.maxY or self.getY() < self.minY): #Abprallen von der Bande
            if(self.getY() > self.maxY):
                self.setY(self.maxY)
            else:
                self.setY(self.minY)
                
            richtung = 360 - richtung
        
        if (richtung < 0):
            richtung = richtung + 360
            
        if (richtung >= 360):
            richtung = richtung - 360
            
        self.setDirection(richtung)
        
    def schlagen(self):#Wird bei Kollision ausgefuehrt
        richtung = self.getDirection()        
        richtung = 180 - richtung   
        richtung = richtung + randint(-self.randFaktor,self.randFaktor)
        
        if (richtung < 0):
            richtung = richtung + 360
            
        if (richtung >= 360):
            richtung = richtung - 360
            
        self.setDirection(richtung)
        
        if (self.getX() >= 100 and self.getX() < self.winX - 100): #Wenn es ein Hindernis war: temporaerer speedboost
            self.speedCounter = 80
        
    def setRandDirection(self): #Setze zufaelligen Winkel in einem bestimmten Bereich
        if (randint(1,2) == 1):
            self.setDirection(randint(140,220))
        else:
            if (randint(1,2) == 1):
                self.setDirection(randint(0,30))
            else:
                self.setDirection(randint(330,359))
        