from random import *
from gamegrid import *
from hindernis import Hindernis
class HindernisSystem():
    def __init__(self, window, winX, winY):
        self.window = window
        self.hindernisList = [] #Liste aus Hindernissen
        self.minX = 100
        self.maxX = winX - 100
        self.minY = 100
        self.maxY = winY - 100
        
    def update(self, ball, ballCollisionListener):        
        if (randint(0,500) == 1 and len(self.hindernisList) < 3):
            self.erstelleHindernis(ball, ballCollisionListener) #Erzeuge neues Hindernis
            
        for h in self.hindernisList:
            if (h.getLeben() <= 0):
                self.window.removeActor(h)
                self.hindernisList.remove(h)
            
    def erstelleHindernis(self, ball, ballCollisionListener):
    
        tex = "sprites/hindernis"
        tex += str(randint(1,4)) #Waehlt eine zufaellige Hindernistextur aus
        tex += ".png"
        
        #Fuege zur Kollisions Liste hinzu
        self.hindernisList.append((Hindernis(tex, 60 + randint(0,70))))
        self.window.addActor(self.hindernisList[-1], Location(randint(0, (self.maxX - self.minX)//20)*20 + self.minX, randint(self.minY, self.maxY)))
        
        ball.addCollisionActor(self.hindernisList[-1])
        self.hindernisList[-1].addActorCollisionListener(ballCollisionListener)
        ball.addActorCollisionListener(ballCollisionListener)
        
            