from gamegrid import *
from random import *
from schlaeger import Schlaeger
from ball import Ball
from collisionListenerBall import CollisionListenerBall
from spieler import Spieler
from anzeige import Anzeige

winX = 1100
winY = 650
rand = 64

def keyCallback(keyCode):
    Schlaeger.setzeRichtung(keyCode, spielerL.schlaeger, spielerR.schlaeger, ball)
    
    if keyCode == 32:
        if (ball.start == False):
            ball.start = True
            anzeige.updateBG()
        
#Rendert den Willkommenstext
def renderStarttext():
    window.getBg().setFont(Font("Impact",0, 16))
    window.getBg().drawText("Willkommen zu Pong! Steuere den linken Schläger mit den Tasten w und s und den rechten Schläger mit den Tasten i und k!", Point(150,winY//5))
    window.getBg().drawText("Drücke Leertaste nach jedem Punkt. Wer 10 Punkte hat gewinnt!", Point(150,winY//5 + 20))
    window.getBg().setFont(Font("Impact", 0, 60))
    window.getBg().drawText("Drücke Leertaste um zu starten!", Point(150,winY//3))
        
window = makeGameGrid(winX, winY, 1, None, "sprites/PongBG.png", False, keyRepeated = keyCallback) #Erstelle das Fenster
window.show()
renderStarttext()

#Objekte werden erstellt
ballCollisionListener = CollisionListenerBall()
spielerL = Spieler(winY, "sprites/schlaegerBlau.png")
spielerR = Spieler(winY, "sprites/schlaegerRot.png")
anzeige = Anzeige(window, spielerL, spielerR, winX)
ball = Ball(winX, winY, anzeige, window, ballCollisionListener)

window.setTitle("Pong")

#Adde die Actors zum window
window.addActor(spielerL.schlaeger, Location(rand,winY//2))
window.addActor(spielerR.schlaeger, Location(winX-rand-1,winY//2))
window.addActor(ball, Location(winX//2 - 2,winY//2 - 2))

#Bereite Kollisionserkennung vor
ball.addCollisionActor(spielerL.schlaeger)
ball.addCollisionActor(spielerR.schlaeger)

spielerL.schlaeger.addActorCollisionListener(ballCollisionListener)
spielerR.schlaeger.addActorCollisionListener(ballCollisionListener)
ball.addActorCollisionListener(ballCollisionListener)

ball.setRandDirection()
ball.setSlowDown(2)
        
spielerL.schlaeger.setDirection(90)
spielerR.schlaeger.setDirection(90)

ball.setSlowDown(2)
spielerL.schlaeger.setSlowDown(2)
spielerR.schlaeger.setSlowDown(2)

#Wenn Leertaste gedrueckt wird geht das Spiel los
while True:
    renderStarttext()
    key = getKeyCodeWait()
    if key == 32:
        ball.start = True
        anzeige.updateBG()
        break

setSimulationPeriod(5)
window.doRun()